/*
 * This file is part of libportable.
 * Copyright (C) 2008-2009 David Sveningsson <ext@sidvind.com>
 * 
 * libportable is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * libportable is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with libportable.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <portable/env.h>
#include <errno.h>
#include <stdlib.h>

int dupenv(char** buffer, size_t* numberOfElements, const char *varname){
	char* tmp;

	if ( numberOfElements ){
		*numberOfElements = 0;
	}

	if ( !buffer || !varname ){
		errno = EINVAL;
		return EINVAL;
	}

	tmp = getenv(varname);

	if ( !tmp ){
		*buffer = NULL;
	} else {
		*buffer = strdup(tmp);

		if ( numberOfElements ){
			*numberOfElements = strlen(*buffer) + 1;
		}
	}

	return 0;
}
