/*
 * This file is part of libportable.
 * Copyright (C) 2008-2009 David Sveningsson <ext@sidvind.com>
 * 
 * libportable is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * libportable is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with libportable.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifdef HAVE_CONFIG_
#	include "config.h"
#endif

#ifdef HAVE_GMTIME_R
#	error System implementation of gmtime_r is available
#endif

#include <time.h>


struct tm* gmtime_r(const time_t* timep, struct tm* result){
/* MSVC 2005+ has gmtime_s which is essentially the same, just need to match
 * the prototypes. */
#if _MSC_VER >= 1400
	if ( gmtime_s(result, timep) == 0 ){
		return result;
	} else {
		return NULL;
	}
#else
	/* @todo Not threadsafe! */
	struct tm* tmp = gmtime(timep);

	if ( !tmp ){
		return NULL;
	}

	*result = *tmp;
	return result;
#endif
}
