/*
 * This file is part of libportable.
 * Copyright (C) 2008-2010 David Sveningsson <ext@sidvind.com>
 * 
 * libportable is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * libportable is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with libportable.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>

char* strtok_s(char* str, const char* delim, char** saveptr){
	/* must set delimiter and saveptr */
	if ( !(delim && saveptr) ){
		errno = EINVAL;
		return NULL;
	}

	/* saveptr must be set by a previous call to strtok_s */
	if ( !str && !*saveptr ){
		errno = EINVAL;
		return NULL;
	}

	return strtok_r(str, delim, saveptr);
}
