/*
 * This file is part of libportable.
 * Copyright (C) 2008-2009 David Sveningsson <ext@sidvind.com>
 * 
 * libportable is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * libportable is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with libportable.  If not, see <http://www.gnu.org/licenses/>.
 */

/* It was hard enough to get a replacement to work, I won't try to get the 
 * security enhanced versions working. */
#define _CRT_SECURE_NO_WARNINGS

#include <portable/vscanf.h>
#include <string.h>

int vscanf(const char *format, va_list ap){
	return -1;
}

int vsscanf(const char *src, const char *format, va_list ap){
	/* This code is based on code from:
	 * http://www.gamedev.net/community/forums/topic.asp?topic_id=310888 */

    size_t count = 0;
	size_t stackSize = 0;

	int i;
	int result = 0;
	int stackAdvance;

    const char *p = format;
    while(1)
    {
        char c = *(p++);
        if(c==0) break;
        if(c=='%' && (p[0]!='*' && p[0]!='%')) ++count;
    }

	if (count <= 0)
		return 0;

    // copy stack pointer
	_asm
	{
		mov esi, esp;
	}

	// push variable parameters pointers on stack
	for (i = count - 1; i >= 0; --i)
	{
		_asm
		{
			mov eax, dword ptr[i];
			mov ecx, dword ptr [ap];
			mov edx, dword ptr [ecx+eax*4];
			push edx;
		}
	}

	stackAdvance = (2 + count) * sizeof(void*);

	_asm
	{
		// now push on the fixed params
		mov eax, dword ptr [format];
		push eax;
		mov eax, dword ptr [src];
		push eax;

		// call sscanf, and more the result in to result
		call dword ptr [sscanf];
		mov result, eax;

		// restore stack pointer
		mov eax, dword ptr[stackAdvance];
		add esp, eax;
		//mov esp, esi;
	}

	return result;


}

int vfscanf(FILE *stream, const char *format, va_list ap){
	return -1;
}
